blob: 8302c85a4a218cb34ea8870099fed1e803b0dbd5 [file] [log] [blame]
Tristan Muntsinger82c10502019-10-15 14:49:19 -07001#!/bin/bash
2
3# Copyright 2019 Google Inc. All rights reserved.
4
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8
9# http://www.apache.org/licenses/LICENSE-2.0
10
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17source "${ANDROID_BUILD_TOP}/external/shflags/src/shflags"
18
Tristan Muntsinger34569112019-10-16 22:10:54 -070019DEFINE_boolean p1 \
20 false "Only generate/write the 1st partition (loader1)" "1"
21DEFINE_boolean p2 \
22 false "Only generate/write the 2nd partition (env)" "2"
23DEFINE_boolean p3 \
24 false "Only generate/write the 3rd partition (loader2)" "3"
25DEFINE_boolean p4 \
26 false "Only generate/write the 4th partition (trust)" "4"
27DEFINE_boolean p5 \
28 false "Only generate/write the 5th partition (rootfs)" "5"
29
30FLAGS_HELP="USAGE: $0 <KERNEL_DIR> [IMAGE] [flags]"
Tristan Muntsinger82c10502019-10-15 14:49:19 -070031
32FLAGS "$@" || exit $?
33eval set -- "${FLAGS_ARGV}"
34
Tristan Muntsinger34569112019-10-16 22:10:54 -070035if [ ${FLAGS_p1} -eq ${FLAGS_FALSE} ] &&
36 [ ${FLAGS_p2} -eq ${FLAGS_FALSE} ] &&
37 [ ${FLAGS_p3} -eq ${FLAGS_FALSE} ] &&
38 [ ${FLAGS_p4} -eq ${FLAGS_FALSE} ] &&
39 [ ${FLAGS_p5} -eq ${FLAGS_FALSE} ]; then
40 FLAGS_p1=${FLAGS_TRUE}
41 FLAGS_p2=${FLAGS_TRUE}
42 FLAGS_p3=${FLAGS_TRUE}
43 FLAGS_p4=${FLAGS_TRUE}
44 FLAGS_p5=${FLAGS_TRUE}
45fi
46
Tristan Muntsinger82c10502019-10-15 14:49:19 -070047for arg in "$@" ; do
48 if [ -z $KERNEL_DIR ]; then
49 KERNEL_DIR=$arg
50 elif [ -z $IMAGE ]; then
51 IMAGE=$arg
52 else
53 flags_help
54 exit 1
55 fi
56done
57
Tristan Muntsingere4eeded2019-10-15 20:26:15 -070058USE_IMAGE=`[ -z "${IMAGE}" ] && echo "0" || echo "1"`
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -070059OVERWRITE=`[ -e "${IMAGE}" ] && echo "1" || echo "0"`
60if [ -z $KERNEL_DIR ]; then
Tristan Muntsinger82c10502019-10-15 14:49:19 -070061 flags_help
62 exit 1
63fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -070064if [ ! -e "${KERNEL_DIR}" ]; then
65 echo "error: can't find '${KERNEL_DIR}'. aborting..."
66 exit 1
67fi
68
69# escalate to superuser
70if [ $UID -ne 0 ]; then
71 cd ${ANDROID_BUILD_TOP}
72 . ./build/envsetup.sh
73 lunch ${TARGET_PRODUCT}-${TARGET_BUILD_VARIANT}
74 mmma external/u-boot
75 cd -
76 exec sudo -E "${0}" ${@}
77fi
78
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -070079if [ $OVERWRITE -eq 1 ]; then
80 OVERWRITE_IMAGE=${IMAGE}
81 IMAGE=`mktemp`
82fi
83
Tristan Muntsingere4eeded2019-10-15 20:26:15 -070084if [ $USE_IMAGE -eq 0 ]; then
85 init_devs=`lsblk --nodeps -oNAME -n`
86 echo "Reinsert device (to write to) into PC"
87 while true; do
88 devs=`lsblk --nodeps -oNAME -n`
89 new_devs="$(echo -e "${init_devs}\n${devs}" | sort | uniq -u | awk 'NF')"
90 num_devs=`echo "${new_devs}" | wc -l`
91 if [[ "${new_devs}" == "" ]]; then
92 num_devs=0
93 fi
94 if [[ ${num_devs} -gt 1 ]]; then
95 echo "error: too many new devices detected! aborting..."
96 exit 1
97 fi
98 if [[ ${num_devs} -eq 1 ]]; then
99 if [[ "${new_devs}" != "${mmc_dev}" ]]; then
100 if [[ "${mmc_dev}" != "" ]]; then
101 echo "error: block device name mismatch ${new_devs} != ${mmc_dev}"
102 echo "Reinsert device (to write to) into PC"
103 fi
104 mmc_dev=${new_devs}
105 continue
106 fi
107 echo "${init_devs}" | grep "${mmc_dev}" >/dev/null
108 if [[ $? -eq 0 ]]; then
109 init_devs="${devs}"
110 continue
111 fi
112 break
113 fi
114 done
115 # now inform the user
116 echo "Detected device at /dev/${mmc_dev}"
117fi
118
Tristan Muntsinger34569112019-10-16 22:10:54 -0700119if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
120 cd ${ANDROID_BUILD_TOP}/external/arm-trusted-firmware
121 CROSS_COMPILE=aarch64-linux-gnu- make PLAT=rk3399 DEBUG=0 ERROR_DEPRECATED=1 bl31
122 export BL31="${ANDROID_BUILD_TOP}/external/arm-trusted-firmware/build/rk3399/release/bl31/bl31.elf"
123 cd -
124fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700125
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700126cd ${ANDROID_BUILD_TOP}/external/u-boot
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700127
Tristan Muntsinger34569112019-10-16 22:10:54 -0700128if [ ${FLAGS_p2} -eq ${FLAGS_TRUE} ]; then
129 tmpfile=`mktemp`
130 bootenv=`mktemp`
131 cat > ${tmpfile} << "EOF"
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700132bootdelay=2
133baudrate=1500000
134scriptaddr=0x00500000
135boot_targets=mmc1 mmc0
136bootcmd=run distro_bootcmd
137distro_bootcmd=for target in ${boot_targets}; do run bootcmd_${target}; done
138bootcmd_mmc0=devnum=0; run mmc_boot
139bootcmd_mmc1=devnum=1; run mmc_boot
140mmc_boot=if mmc dev ${devnum}; then ; run scan_for_boot_part; fi
141scan_for_boot_part=part list mmc ${devnum} -bootable devplist; env exists devplist || setenv devplist 1; for part in ${devplist}; do if fstype mmc ${devnum}:${part} bootfstype; then run find_init_script; fi; done; setenv devplist
142find_init_script=if test -e mmc ${devnum}:${part} /boot/init.scr; then echo Found U-Boot script /boot/init.scr; run init_scr; fi
143init_scr=load mmc ${devnum}:${part} ${scriptaddr} /boot/init.scr; source ${scriptaddr}
144EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700145 ${ANDROID_HOST_OUT}/bin/mkenvimage -s 32768 -o ${bootenv} - < ${tmpfile}
146fi
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700147
Tristan Muntsinger34569112019-10-16 22:10:54 -0700148if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ] || [ ${FLAGS_p3} -eq ${FLAGS_TRUE} ]; then
149 make ARCH=arm CROSS_COMPILE=aarch64-linux-gnu- rock-pi-4-rk3399_defconfig
150 if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
151 make ARCH=arm CROSS_COMPILE=aarch64-linux-gnu- -j`nproc`
152 fi
153 if [ ${FLAGS_p3} -eq ${FLAGS_TRUE} ]; then
154 make ARCH=arm CROSS_COMPILE=aarch64-linux-gnu- u-boot.itb
155 fi
156 if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
157 idbloader=`mktemp`
158 ${ANDROID_HOST_OUT}/bin/mkimage -n rk3399 -T rksd -d tpl/u-boot-tpl.bin ${idbloader}
159 cat spl/u-boot-spl.bin >> ${idbloader}
160 fi
161fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700162cd -
163
Tristan Muntsinger34569112019-10-16 22:10:54 -0700164if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
165 ${ANDROID_BUILD_TOP}/kernel/tests/net/test/build_rootfs.sh -a arm64 -s buster -n ${IMAGE}
166 if [ $? -ne 0 ]; then
167 echo "error: failed to build rootfs. exiting..."
168 exit 1
169 fi
170 truncate -s +3G ${IMAGE}
171 e2fsck -f ${IMAGE}
172 resize2fs ${IMAGE}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700173
Tristan Muntsinger34569112019-10-16 22:10:54 -0700174 mntdir=`mktemp -d`
175 mount ${IMAGE} ${mntdir}
176 if [ $? != 0 ]; then
177 echo "error: unable to mount ${IMAGE} ${mntdir}"
178 exit 1
179 fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700180
Tristan Muntsinger34569112019-10-16 22:10:54 -0700181 cat > ${mntdir}/boot/init.cmd << "EOF"
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700182mmc dev 1 0; mmc read 0x02080000 0x1fc0 0x40;
183ethaddr=$ethaddr
184env default -a
185setenv ethaddr $ethaddr
186setenv boot_targets 'mmc1 mmc0 usb0 pxe'
187saveenv
188mmc dev 1 0; mmc read 0x04000000 0x1fc0 0x40;
189mmc dev 0 0; mmc write 0x04000000 0x1fc0 0x40;
190mmc dev 1 0; mmc write 0x02080000 0x1fc0 0x40;
191EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700192 ${ANDROID_BUILD_TOP}/external/u-boot/tools/mkimage \
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700193 -C none -A arm -T script -d ${mntdir}/boot/init.cmd ${mntdir}/boot/init.scr
194
Tristan Muntsinger34569112019-10-16 22:10:54 -0700195 cat > ${mntdir}/boot/boot.cmd << "EOF"
Tristan Muntsingerbcdc07b2019-10-16 22:56:19 -0700196setenv bootcmd_dhcp '
197mw.b ${scriptaddr} 0 0x8000
198mmc dev 0 0
199mmc read ${scriptaddr} 0x1fc0 0x40
200env import -b ${scriptaddr} 0x8000
201mw.b ${scriptaddr} 0 0x8000
202if dhcp ${scriptaddr} manifest.txt; then
203 setenv OldSha ${Sha}
204 setenv Sha
205 env import -t ${scriptaddr} 0x8000 ManifestVersion
206 if test "$ManifestVersion" = "1"; then
207 run manifest1
208 else
209 run manifestX
210 fi
211fi'
212setenv manifestX 'echo "***** ERROR: Unknown manifest version! *****";'
213setenv manifest1 '
214echo "Manifest version 1";
215env import -t ${scriptaddr} 0x8000
216if test "$Sha" != "$OldSha"; then
217 setenv serverip ${TftpServer}
218 setenv loadaddr 0x00200000
219 mmc dev 0 0;
220 file=$TplSplImg; offset=0x40; size=0x1f80; run tftpget1; setenv TplSplImg
221 file=$UbootItb; offset=0x4000; size=0x2000; run tftpget1; setenv UbootItb
222 file=$TrustImg; offset=0x6000; size=0x2000; run tftpget1; setenv TrustImg
223 file=$RootfsImg; offset=0x8000; size=0; run tftpget1; setenv RootfsImg
224 file=$UbootEnv; offset=0x1fc0; size=0x40; run tftpget1; setenv UbootEnv
225 mw.b ${scriptaddr} 0 0x8000
226 env export -b ${scriptaddr} 0x8000
227 mmc write ${scriptaddr} 0x1fc0 0x40
228else
229 echo "Already have ${Sha}. Booting..."
230fi'
231setenv tftpget1 "
232mw.b ${loadaddr} 0 0x400000
233&& tftp ${file}
234&& isGz=0 && setexpr isGz sub .*\\.gz\$ 1 ${file}
235&& if test $isGz = 1; then
236 setexpr boffset ${offset} * 0x200
237 && gzwrite mmc 0 ${loadaddr} 0x${filesize} 100000 ${boffset}
238 && echo Updated: ${bootfile}
239elif test ${file} = boot.env; then
240 env import -b ${loadaddr}
241 && echo Updated: boot.env
242else
243 && if test $size = 0; then
244 setexpr x $filesize - 1
245 && setexpr x $x / 0x1000
246 && setexpr x $x + 1
247 && setexpr x $x * 0x1000
248 && setexpr x $x / 0x200
249 && size=0x${x}
250 fi
251 && mmc write ${loadaddr} ${offset} ${size}
252 && echo Updated: ${bootfile}
253fi
254|| echo ** UPDATE FAILED: ${bootfile} **"
255if mmc dev 1 0; then; else
256 run bootcmd_dhcp;
257fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700258load mmc ${devnum}:${distro_bootpart} 0x02080000 /boot/Image
259load mmc ${devnum}:${distro_bootpart} 0x04000000 /boot/uInitrd
260load mmc ${devnum}:${distro_bootpart} 0x01f00000 /boot/dtb/rockchip/rk3399-rock-pi-4.dtb
261setenv finduuid "part uuid mmc ${devnum}:${distro_bootpart} uuid"
262run finduuid
263setenv bootargs "earlycon=uart8250,mmio32,0xff1a0000 console=ttyS2,1500000n8 loglevel=7 root=PARTUUID=${uuid} rootwait rootfstype=ext4 sdhci.debug_quirks=0x20000000"
264booti 0x02080000 0x04000000 0x01f00000
265EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700266 ${ANDROID_HOST_OUT}/bin/mkimage \
267 -C none -A arm -T script -d ${mntdir}/boot/boot.cmd ${mntdir}/boot/boot.scr
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700268
Tristan Muntsinger34569112019-10-16 22:10:54 -0700269 cd ${KERNEL_DIR}
270 export PATH=${ANDROID_BUILD_TOP}/prebuilts/clang/host/linux-x86/clang-r353983c/bin:$PATH
271 export PATH=${ANDROID_BUILD_TOP}/prebuilts/gcc/linux-x86/aarch64/aarch64-linux-android-4.9/bin:$PATH
272 make ARCH=arm64 CC=clang CROSS_COMPILE=aarch64-linux-androidkernel- \
273 CLANG_TRIPLE=aarch64-linux-gnu- rockpi4_defconfig
274 make ARCH=arm64 CC=clang CROSS_COMPILE=aarch64-linux-androidkernel- \
275 CLANG_TRIPLE=aarch64-linux-gnu- -j`nproc`
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700276
Tristan Muntsinger34569112019-10-16 22:10:54 -0700277 cp ${KERNEL_DIR}/arch/arm64/boot/Image ${mntdir}/boot/
278 mkdir -p ${mntdir}/boot/dtb/rockchip/
279 cp ${KERNEL_DIR}/arch/arm64/boot/dts/rockchip/rk3399-rock-pi-4.dtb ${mntdir}/boot/dtb/rockchip/
280 cd -
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700281
Tristan Muntsinger34569112019-10-16 22:10:54 -0700282 mount -o bind /proc ${mntdir}/proc
283 mount -o bind /sys ${mntdir}/sys
284 mount -o bind /dev ${mntdir}/dev
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700285
Tristan Muntsinger34569112019-10-16 22:10:54 -0700286 echo "Installing required packages..."
287 chroot ${mntdir} /bin/bash <<EOF
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700288apt-get update
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700289apt-get install -y -f initramfs-tools u-boot-tools network-manager openssh-server sudo man-db vim git dpkg-dev cdbs debhelper config-package-dev gdisk eject lzop binfmt-support ntpdate
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700290EOF
291
Tristan Muntsinger34569112019-10-16 22:10:54 -0700292 echo "Turning on DHCP client..."
293 cat >${mntdir}/etc/systemd/network/dhcp.network <<EOF
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700294[Match]
295Name=en*
296
297[Network]
298DHCP=yes
299EOF
300
Tristan Muntsinger34569112019-10-16 22:10:54 -0700301 chroot ${mntdir} /bin/bash << "EOT"
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700302echo "Adding user vsoc-01 and groups..."
303useradd -m -G kvm,sudo -d /home/vsoc-01 --shell /bin/bash vsoc-01
304echo -e "cuttlefish\ncuttlefish" | passwd
305echo -e "cuttlefish\ncuttlefish" | passwd vsoc-01
306EOT
307
Tristan Muntsinger34569112019-10-16 22:10:54 -0700308 echo "Cloning android-cuttlefish..."
309 cd ${mntdir}/home/vsoc-01
310 git clone https://github.com/google/android-cuttlefish.git
311 cd -
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700312
Tristan Muntsinger34569112019-10-16 22:10:54 -0700313 echo "Creating led script..."
314 cat > ${mntdir}/usr/local/bin/led << "EOF"
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700315#!/bin/bash
316
317if [ "$1" == "--start" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700318 echo 125 > /sys/class/gpio/export
319 echo out > /sys/class/gpio/gpio125/direction
320 chmod 666 /sys/class/gpio/gpio125/value
321 echo 0 > /sys/class/gpio/gpio125/value
322 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700323fi
324
325if [ "$1" == "--stop" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700326 echo 0 > /sys/class/gpio/gpio125/value
327 echo 125 > /sys/class/gpio/unexport
328 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700329fi
330
331if [ ! -e /sys/class/gpio/gpio125/value ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700332 echo "error: led service not initialized"
333 exit 1
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700334fi
335
336if [ "$1" == "0" ] || [ "$1" == "off" ] || [ "$1" == "OFF" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700337 echo 0 > /sys/class/gpio/gpio125/value
338 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700339fi
340
341if [ "$1" == "1" ] || [ "$1" == "on" ] || [ "$1" == "ON" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700342 echo 1 > /sys/class/gpio/gpio125/value
343 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700344fi
345
346echo "usage: led <0|1>"
347exit 1
348EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700349 chown root:root ${mntdir}/usr/local/bin/led
350 chmod 755 ${mntdir}/usr/local/bin/led
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700351
Tristan Muntsinger34569112019-10-16 22:10:54 -0700352 echo "Creating led service..."
353 cat > ${mntdir}/etc/systemd/system/led.service << EOF
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700354[Unit]
355 Description=led service
356 ConditionPathExists=/usr/local/bin/led
357
358[Service]
359 Type=oneshot
360 ExecStart=/usr/local/bin/led --start
361 ExecStop=/usr/local/bin/led --stop
362 RemainAfterExit=true
363 StandardOutput=journal
364
365[Install]
366 WantedBy=multi-user.target
367EOF
368
Tristan Muntsinger34569112019-10-16 22:10:54 -0700369 echo "Creating SD duplicator script..."
370 cat > ${mntdir}/usr/local/bin/sd-dupe << "EOF"
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700371#!/bin/bash
372led 0
373
374src_dev=mmcblk0
375dest_dev=mmcblk1
376part_num=p5
377
378if [ -e /dev/mmcblk0p5 ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700379 led 1
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700380
Tristan Muntsinger34569112019-10-16 22:10:54 -0700381 sgdisk -Z -a1 /dev/${dest_dev}
382 sgdisk -a1 -n:1:64:8127 -t:1:8301 -c:1:loader1 /dev/${dest_dev}
383 sgdisk -a1 -n:2:8128:8191 -t:2:8301 -c:2:env /dev/${dest_dev}
384 sgdisk -a1 -n:3:16384:24575 -t:3:8301 -c:3:loader2 /dev/${dest_dev}
385 sgdisk -a1 -n:4:24576:32767 -t:4:8301 -c:4:trust /dev/${dest_dev}
386 sgdisk -a1 -n:5:32768:- -A:5:set:2 -t:5:8305 -c:5:rootfs /dev/${dest_dev}
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700387
Tristan Muntsinger34569112019-10-16 22:10:54 -0700388 src_block_count=`tune2fs -l /dev/${src_dev}${part_num} | grep "Block count:" | sed 's/.*: *//'`
389 src_block_size=`tune2fs -l /dev/${src_dev}${part_num} | grep "Block size:" | sed 's/.*: *//'`
390 src_fs_size=$(( src_block_count*src_block_size ))
391 src_fs_size_m=$(( src_fs_size / 1024 / 1024 + 1 ))
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700392
Tristan Muntsinger34569112019-10-16 22:10:54 -0700393 dd if=/dev/${src_dev}p1 of=/dev/${dest_dev}p1 conv=sync,noerror status=progress
394 dd if=/dev/${src_dev}p2 of=/dev/${dest_dev}p2 conv=sync,noerror status=progress
395 dd if=/dev/${src_dev}p3 of=/dev/${dest_dev}p3 conv=sync,noerror status=progress
396 dd if=/dev/${src_dev}p4 of=/dev/${dest_dev}p4 conv=sync,noerror status=progress
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700397
Tristan Muntsinger34569112019-10-16 22:10:54 -0700398 echo "Writing ${src_fs_size_m} MB: /dev/${src_dev} -> /dev/${dest_dev}..."
399 dd if=/dev/${src_dev}${part_num} of=/dev/${dest_dev}${part_num} bs=1M conv=sync,noerror status=progress
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700400
Tristan Muntsinger34569112019-10-16 22:10:54 -0700401 echo "Expanding /dev/${dest_dev}${part_num} filesystem..."
402 e2fsck -fy /dev/${dest_dev}${part_num}
403 resize2fs /dev/${dest_dev}${part_num}
404 tune2fs -O has_journal /dev/${dest_dev}${part_num}
405 e2fsck -fy /dev/${dest_dev}${part_num}
406 sync /dev/${dest_dev}
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700407
Tristan Muntsinger34569112019-10-16 22:10:54 -0700408 echo "Cleaning up..."
409 mount /dev/${dest_dev}${part_num} /media
410 chroot /media /usr/local/bin/install-cleanup
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700411
Tristan Muntsinger34569112019-10-16 22:10:54 -0700412 if [ $? == 0 ]; then
413 echo "Successfully copied Rock Pi image!"
414 while true; do
415 led 1; sleep 0.5
416 led 0; sleep 0.5
417 done
418 else
419 echo "Error while copying Rock Pi image"
420 while true; do
421 led 1; sleep 0.1
422 led 0; sleep 0.1
423 done
424 fi
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700425else
Tristan Muntsinger34569112019-10-16 22:10:54 -0700426 echo "Expanding /dev/${dest_dev}${part_num} filesystem..."
427 e2fsck -fy /dev/${dest_dev}${part_num}
428 resize2fs /dev/${dest_dev}${part_num}
429 tune2fs -O has_journal /dev/${dest_dev}${part_num}
430 e2fsck -fy /dev/${dest_dev}${part_num}
431 sync /dev/${dest_dev}
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700432
Tristan Muntsinger34569112019-10-16 22:10:54 -0700433 echo "Cleaning up..."
434 /usr/local/bin/install-cleanup
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700435fi
436EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700437 chmod +x ${mntdir}/usr/local/bin/sd-dupe
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700438
Tristan Muntsinger34569112019-10-16 22:10:54 -0700439 echo "Creating SD duplicator service..."
440 cat > ${mntdir}/etc/systemd/system/sd-dupe.service << EOF
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700441[Unit]
442 Description=Duplicate SD card rootfs to eMMC on Rock Pi
443 ConditionPathExists=/usr/local/bin/sd-dupe
444 After=led.service
445
446[Service]
447 Type=simple
448 ExecStart=/usr/local/bin/sd-dupe
449 TimeoutSec=0
450 StandardOutput=tty
451
452[Install]
453 WantedBy=multi-user.target
454EOF
455
Tristan Muntsinger34569112019-10-16 22:10:54 -0700456 echo "Creating cleanup script..."
457 cat > ${mntdir}/usr/local/bin/install-cleanup << "EOF"
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700458#!/bin/bash
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700459echo "Installing cuttlefish-common package..."
460echo "nameserver 8.8.8.8" > /etc/resolv.conf
461MAC=`ip link | grep eth0 -A1 | grep ether | sed 's/.*\(..:..:..:..:..:..\) .*/\1/'`
462sed -i " 1 s/.*/& rockpi-${MAC}/" /etc/hosts
463sudo hostnamectl set-hostname "rockpi-${MAC}"
464
465dpkg --add-architecture amd64
466until ping -c1 ftp.debian.org; do sleep 1; done
467ntpdate time.google.com
468while true; do
469 apt-get -o Acquire::Check-Valid-Until=false update
470 if [ $? != 0 ]; then sleep 1; continue; fi
471 apt-get install -y -f libc6:amd64 qemu-user-static
472 if [ $? != 0 ]; then sleep 1; continue; fi
473 break
474done
475cd /home/vsoc-01/android-cuttlefish
476dpkg-buildpackage -d -uc -us
477apt-get install -y -f ../cuttlefish-common_*_arm64.deb
478apt-get clean
479usermod -aG cvdnetwork vsoc-01
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700480chmod 660 /dev/vhost-vsock
481chown root:cvdnetwork /dev/vhost-vsock
482
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700483rm /etc/machine-id
484rm /var/lib/dbus/machine-id
485dbus-uuidgen --ensure
486systemd-machine-id-setup
487
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700488systemctl disable sd-dupe
489rm /etc/systemd/system/sd-dupe.service
490rm /usr/local/bin/sd-dupe
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700491rm /usr/local/bin/install-cleanup
492EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700493 chmod +x ${mntdir}/usr/local/bin/install-cleanup
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700494
Tristan Muntsinger34569112019-10-16 22:10:54 -0700495 chroot ${mntdir} /bin/bash << "EOT"
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700496echo "Enabling services..."
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700497systemctl enable led
498systemctl enable sd-dupe
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700499
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700500echo "Creating Initial Ramdisk..."
501update-initramfs -c -t -k "5.2.0"
502mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 -n uInitrd -d /boot/initrd.img-5.2.0 /boot/uInitrd-5.2.0
503ln -s /boot/uInitrd-5.2.0 /boot/uInitrd
504EOT
505
Tristan Muntsinger34569112019-10-16 22:10:54 -0700506 umount ${mntdir}/sys
507 umount ${mntdir}/dev
508 umount ${mntdir}/proc
509 umount ${mntdir}
510
511 # Turn on journaling
512 tune2fs -O ^has_journal ${IMAGE}
513 e2fsck -fy ${IMAGE} >/dev/null 2>&1
514fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700515
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700516if [ ${USE_IMAGE} -eq 0 ]; then
517 # 32GB eMMC size
Tristan Muntsinger34569112019-10-16 22:10:54 -0700518 end_sector=61071326
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700519 device=/dev/${mmc_dev}
520 devicep=${device}
521
522 sgdisk -Z -a1 ${device}
523 sgdisk -a1 -n:1:64:8127 -t:1:8301 -c:1:loader1 ${device}
524 sgdisk -a1 -n:2:8128:8191 -t:2:8301 -c:2:env ${device}
525 sgdisk -a1 -n:3:16384:24575 -t:3:8301 -c:3:loader2 ${device}
526 sgdisk -a1 -n:4:24576:32767 -t:4:8301 -c:4:trust ${device}
Tristan Muntsinger34569112019-10-16 22:10:54 -0700527 sgdisk -a1 -n:5:32768:${end_sector} -A:5:set:2 -t:5:8305 -c:5:rootfs ${device}
528 if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
529 dd if=${IMAGE} of=${devicep}5 bs=1M
530 resize2fs ${devicep}5 >/dev/null 2>&1
531 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700532else
Tristan Muntsinger34569112019-10-16 22:10:54 -0700533 device=$(losetup -f)
534 devicep=${device}p
535 if [ ${FLAGS_p5} -eq ${FLAGS_FALSE} ]; then
536 fs_end=3G
537 end_sector=-
538 fi
539 if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
540 # Minimize rootfs filesystem
541 while true; do
542 out=`sudo resize2fs -M ${IMAGE} 2>&1`
543 if [[ $out =~ "Nothing to do" ]]; then
544 break
545 fi
546 done
547 # Minimize rootfs file size
548 block_count=`sudo tune2fs -l ${IMAGE} | grep "Block count:" | sed 's/.*: *//'`
549 block_size=`sudo tune2fs -l ${IMAGE} | grep "Block size:" | sed 's/.*: *//'`
550 sector_size=512
551 start_sector=32768
552 fs_size=$(( block_count*block_size ))
553 fs_sectors=$(( fs_size/sector_size ))
554 part_sectors=$(( ((fs_sectors-1)/2048+1)*2048 )) # 1MB-aligned
555 end_sector=$(( start_sector+part_sectors-1 ))
556 secondary_gpt_sectors=33
557 fs_end=$(( (end_sector+secondary_gpt_sectors+1)*sector_size ))
558 image_size=$(( part_sectors*sector_size ))
559 truncate -s ${image_size} ${IMAGE}
560 e2fsck -fy ${IMAGE} >/dev/null 2>&1
561 fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700562
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700563 # Create final image
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -0700564 if [ $OVERWRITE -eq 1 ]; then
565 tmpimg=${OVERWRITE_IMAGE}
566 else
567 tmpimg=`mktemp`
568 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700569 truncate -s ${fs_end} ${tmpimg}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700570
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700571 # Create GPT
572 sgdisk -Z -a1 ${tmpimg}
573 sgdisk -a1 -n:1:64:8127 -t:1:8301 -c:1:loader1 ${tmpimg}
574 sgdisk -a1 -n:2:8128:8191 -t:2:8301 -c:2:env ${tmpimg}
575 sgdisk -a1 -n:3:16384:24575 -t:3:8301 -c:3:loader2 ${tmpimg}
576 sgdisk -a1 -n:4:24576:32767 -t:4:8301 -c:4:trust ${tmpimg}
577 sgdisk -a1 -n:5:32768:${end_sector} -A:5:set:2 -t:5:8305 -c:5:rootfs ${tmpimg}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700578
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700579 losetup ${device} ${tmpimg}
580 partx -v --add ${device}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700581
Tristan Muntsinger34569112019-10-16 22:10:54 -0700582 if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
583 dd if=${IMAGE} of=${devicep}5 bs=1M
584 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700585fi
Tristan Muntsinger34569112019-10-16 22:10:54 -0700586if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
587 dd if=${idbloader} of=${devicep}1
588fi
589if [ ${FLAGS_p2} -eq ${FLAGS_TRUE} ]; then
590 dd if=${bootenv} of=${devicep}2
591fi
592if [ ${FLAGS_p3} -eq ${FLAGS_TRUE} ]; then
593 dd if=${ANDROID_BUILD_TOP}/external/u-boot/u-boot.itb of=${devicep}3
594fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700595if [ ${USE_IMAGE} -eq 1 ]; then
596 chown $SUDO_USER:`id -ng $SUDO_USER` ${tmpimg}
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -0700597 if [ $OVERWRITE -eq 0 ]; then
598 mv ${tmpimg} ${IMAGE}
599 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700600 partx -v --delete ${device}
601 losetup -d ${device}
602fi